#include "progressnotifyjob.h"
#include "kio/global.h"
#include "kjobtrackerinterface.h"
#include "qtimer.h"
#include <klocalizedstring.h>
#include <kjobuidelegate.h>
#include <kwidgetjobtracker.h>
#include <kuiserverjobtracker.h>
#include <kstatusbarjobtracker.h>

ProgressNotifyJob::ProgressNotifyJob(const QString & title, const QPair< QString, QString > & field1, const QPair< QString, QString > &field2):KJob()
{
    //setCapabilities(KJob::Capabilities(KJob::Suspendable|KJob::Killable));
    setCapabilities(KJob::Capabilities(KJob::NoCapabilities));
    //KJobTrackerInterface * tr = KIO::getJobTracker();
    //KWidgetJobTracker * tr = new KWidgetJobTracker();
    KUiServerJobTracker* tr = new KUiServerJobTracker();
    //KStatusBarJobTracker* tr = new KStatusBarJobTracker();
    tr->registerJob(this);
    emit description(this,title,field1,field2);

}

void ProgressNotifyJob::start()
{
    QTimer::singleShot(0,this,SLOT(doWork()));
}


void ProgressNotifyJob::error(QString text)
{
    setErrorText(text);
    setError(-1);
    emitResult();
}

void ProgressNotifyJob::success(QString text)
{
    emit description(this,text);
    emitResult();
}

void ProgressNotifyJob::updatePercent(int value)
{
    setPercent(value);
};

void ProgressNotifyJob::doWork()
{

}
