#ifndef WEBDAV_H
#define WEBDAV_H

#include <string>
#include <map>
#include <vector>
#include "WebDav_p.h"
#include "WebDav_neon.h"
#include "main.h"
#include "sync_obj.h"

using namespace std;
#ifndef USE_LIBNEON
class WebDav: public WebDav_private
#else
class WebDav: public WebDav_neon
#endif
{
public:
	WebDav();
	~WebDav();
private:
	pthread_spinlock_t tlock;
public:
	string getFileSTag(string uname);
	unsigned last_error;
	time_t GetATime(string path);
/*	int SetMode(string uname,mode_t mode);	//TODO: запрашивать за раз
	int SetSTag(string uname,string sTag);*/
	void SetMeta(string uname, map<string, string> meta);
	int GetMode(string uname,mode_t* mode);
	int GetSTag(string uname,string* sTag);
	int GetCL(string uname,unsigned* cl);
	
	int Create_path(const string uname);

//	int Propfind(file_s&);
	int PropPatch();
	int Mkcol(const std::string);
	int Delete(const std::string);
	int Get(string uname, string path);
	int Put(string uname, string path);
	int Lock();
	int Unlock();
	int Options();
//	inline unsigned GetLastError(){return last_error;};
	int TryAuth();
	int GetQuote(long long &max, long long &cur);
	vector<sync_object> GetServerList(string uname=string());
	sync_object GetServerState(string uname);
};
#endif //WEBDAV_H
