#ifndef IPC_PROXY_H
#define IPC_PROXY_H
#include "ipc_interface.h"
#include "ipc_interface_local.h"
#include <string>

#include "../../psyncconfig/include/ipc_interface.h"
#include "../../psyncnotify/include/ipc_interface.h"


class ipc_proxy
{
public:
	enum status{
		NONE,
		SYNC_START,
		SYNC_STOP,
		SYNC_STATUS,
		FILE_ADD,
		FILE_DEL,
		FILE_STATUS,
		DIR_STATUS,
		REQ_LOGIN,
		ACC_VALID,
		PWD_CHANGED,
		NOTE_MSG,
		SET_CHANGED,
		LIST_ALL,

	};

	ipc_proxy(const char* path);
	~ipc_proxy();
	int next();
	int nextb();
	std::string from(){return fpath;};
	int send_old(status st,const char* path, std::string ret=std::string());
	int send(int type,std::string path, std::string ret=std::string());
	inline status getState() {return state;};
	std::string getData();
private:
	status state;
	std::string data;
	int sock;
	std::string spath;
	std::string fpath;
};
#endif
